Index: uspace/lib/net/include/arp_interface.h
===================================================================
--- uspace/lib/net/include/arp_interface.h	(revision 32eceb4ff0c0ddeba47997beaa5d0677aee84d3a)
+++ uspace/lib/net/include/arp_interface.h	(revision 1b22bd45ebc7f42217757e90fa6e5b57f6ed5d1d)
@@ -48,10 +48,10 @@
 
 extern int arp_device_req(int, device_id_t, services_t, services_t,
-    measured_string_t *);
-extern int arp_translate_req(int, device_id_t, services_t, measured_string_t *,
-    measured_string_t **, char **);
+    measured_string_ref);
+extern int arp_translate_req(int, device_id_t, services_t, measured_string_ref,
+    measured_string_ref *, char **);
 extern int arp_clear_device_req(int, device_id_t);
 extern int arp_clear_address_req(int, device_id_t, services_t,
-    measured_string_t *);
+    measured_string_ref);
 extern int arp_clean_cache_req(int);
 extern int arp_connect_module(services_t);
Index: uspace/lib/net/include/generic.h
===================================================================
--- uspace/lib/net/include/generic.h	(revision 32eceb4ff0c0ddeba47997beaa5d0677aee84d3a)
+++ uspace/lib/net/include/generic.h	(revision 1b22bd45ebc7f42217757e90fa6e5b57f6ed5d1d)
@@ -49,8 +49,8 @@
     services_t);
 extern int generic_device_req_remote(int, int, device_id_t, int, services_t);
-extern int generic_get_addr_req(int, int, device_id_t, measured_string_t **,
+extern int generic_get_addr_req(int, int, device_id_t, measured_string_ref *,
     char **);
 extern int generic_packet_size_req_remote(int, int, device_id_t,
-    packet_dimension_t *);
+    packet_dimension_ref);
 extern int generic_received_msg_remote(int, int, device_id_t, packet_id_t,
     services_t, services_t);
@@ -58,5 +58,5 @@
     services_t, services_t);
 extern int generic_translate_req(int, int, device_id_t, services_t,
-    measured_string_t *, size_t, measured_string_t **, char **);
+    measured_string_ref, size_t, measured_string_ref *, char **);
 
 #endif
Index: uspace/lib/net/include/icmp_client.h
===================================================================
--- uspace/lib/net/include/icmp_client.h	(revision 32eceb4ff0c0ddeba47997beaa5d0677aee84d3a)
+++ uspace/lib/net/include/icmp_client.h	(revision 1b22bd45ebc7f42217757e90fa6e5b57f6ed5d1d)
@@ -41,7 +41,7 @@
 #include <net/packet.h>
 
-extern int icmp_client_process_packet(packet_t *, icmp_type_t *, icmp_code_t *,
+extern int icmp_client_process_packet(packet_t, icmp_type_t *, icmp_code_t *,
     icmp_param_t *, icmp_param_t *);
-extern size_t icmp_client_header_length(packet_t *);
+extern size_t icmp_client_header_length(packet_t);
 
 #endif
Index: uspace/lib/net/include/icmp_header.h
===================================================================
--- uspace/lib/net/include/icmp_header.h	(revision 32eceb4ff0c0ddeba47997beaa5d0677aee84d3a)
+++ uspace/lib/net/include/icmp_header.h	(revision 1b22bd45ebc7f42217757e90fa6e5b57f6ed5d1d)
@@ -52,4 +52,9 @@
 typedef struct icmp_echo icmp_echo_t;
 
+/** Type definition of the echo specific data pointer.
+ * @see icmp_echo
+ */
+typedef icmp_echo_t *icmp_echo_ref;
+
 /** Echo specific data. */
 struct icmp_echo {
@@ -64,4 +69,9 @@
  */
 typedef struct icmp_header icmp_header_t;
+
+/** Type definition of the internet control message header pointer.
+ * @see icmp_header
+ */
+typedef icmp_header_t *icmp_header_ref;
 
 /** Internet control message header. */
Index: uspace/lib/net/include/icmp_interface.h
===================================================================
--- uspace/lib/net/include/icmp_interface.h	(revision 32eceb4ff0c0ddeba47997beaa5d0677aee84d3a)
+++ uspace/lib/net/include/icmp_interface.h	(revision 1b22bd45ebc7f42217757e90fa6e5b57f6ed5d1d)
@@ -51,8 +51,8 @@
 
 extern int icmp_destination_unreachable_msg(int, icmp_code_t, icmp_param_t,
-    packet_t *);
-extern int icmp_source_quench_msg(int, packet_t *);
-extern int icmp_time_exceeded_msg(int, icmp_code_t, packet_t *);
-extern int icmp_parameter_problem_msg(int, icmp_code_t, icmp_param_t, packet_t *);
+    packet_t);
+extern int icmp_source_quench_msg(int, packet_t);
+extern int icmp_time_exceeded_msg(int, icmp_code_t, packet_t);
+extern int icmp_parameter_problem_msg(int, icmp_code_t, icmp_param_t, packet_t);
 
 /*@}*/
Index: uspace/lib/net/include/il_interface.h
===================================================================
--- uspace/lib/net/include/il_interface.h	(revision 32eceb4ff0c0ddeba47997beaa5d0677aee84d3a)
+++ uspace/lib/net/include/il_interface.h	(revision 1b22bd45ebc7f42217757e90fa6e5b57f6ed5d1d)
@@ -51,5 +51,5 @@
 
 extern int il_device_state_msg(int, device_id_t, device_state_t, services_t);
-extern int il_received_msg(int, device_id_t, packet_t *, services_t);
+extern int il_received_msg(int, device_id_t, packet_t, services_t);
 extern int il_mtu_changed_msg(int, device_id_t, size_t, services_t);
 
Index: uspace/lib/net/include/il_local.h
===================================================================
--- uspace/lib/net/include/il_local.h	(revision 32eceb4ff0c0ddeba47997beaa5d0677aee84d3a)
+++ uspace/lib/net/include/il_local.h	(revision 1b22bd45ebc7f42217757e90fa6e5b57f6ed5d1d)
@@ -44,6 +44,6 @@
  * @param[out]		answer_count The last parameter for the actual answer in
  *			the answer parameter.
- * @return		EOK on success.
- * @return		Other error codes as defined for the arp_message()
+ * @returns		EOK on success.
+ * @returns		Other error codes as defined for the arp_message()
  *			function.
  */
@@ -59,8 +59,8 @@
  * @param[in] client_connection The client connection processing function. The
  *			module skeleton propagates its own one.
- * @return		EOK on successful module termination.
- * @return		Other error codes as defined for the arp_initialize()
+ * @returns		EOK on successful module termination.
+ * @returns		Other error codes as defined for the arp_initialize()
  *			function.
- * @return		Other error codes as defined for the REGISTER_ME() macro
+ * @returns		Other error codes as defined for the REGISTER_ME() macro
  *			function.
  */
Index: uspace/lib/net/include/ip_client.h
===================================================================
--- uspace/lib/net/include/ip_client.h	(revision 32eceb4ff0c0ddeba47997beaa5d0677aee84d3a)
+++ uspace/lib/net/include/ip_client.h	(revision 1b22bd45ebc7f42217757e90fa6e5b57f6ed5d1d)
@@ -45,9 +45,9 @@
 #include <ip_interface.h>
 
-extern int ip_client_prepare_packet(packet_t *, ip_protocol_t, ip_ttl_t,
-    ip_tos_t, int, size_t);
-extern int ip_client_process_packet(packet_t *, ip_protocol_t *, ip_ttl_t *,
+extern int ip_client_prepare_packet(packet_t, ip_protocol_t, ip_ttl_t, ip_tos_t,
+    int, size_t);
+extern int ip_client_process_packet(packet_t, ip_protocol_t *, ip_ttl_t *,
     ip_tos_t *, int *, size_t *);
-extern size_t ip_client_header_length(packet_t *);
+extern size_t ip_client_header_length(packet_t);
 extern int ip_client_set_pseudo_header_data_length(void *, size_t, size_t);
 extern int ip_client_get_pseudo_header(ip_protocol_t, struct sockaddr *,
Index: uspace/lib/net/include/ip_header.h
===================================================================
--- uspace/lib/net/include/ip_header.h	(revision 32eceb4ff0c0ddeba47997beaa5d0677aee84d3a)
+++ uspace/lib/net/include/ip_header.h	(revision 1b22bd45ebc7f42217757e90fa6e5b57f6ed5d1d)
@@ -127,8 +127,18 @@
 typedef struct ip_header ip_header_t;
 
+/** Type definition of the internet header pointer.
+ * @see ip_header
+ */
+typedef ip_header_t *ip_header_ref;
+
 /** Type definition of the internet option header.
  * @see ip_header
  */
 typedef struct ip_option ip_option_t;
+
+/** Type definition of the internet option header pointer.
+ * @see ip_header
+ */
+typedef ip_option_t *ip_option_ref;
 
 /** Type definition of the internet version 4 pseudo header.
@@ -136,4 +146,9 @@
  */
 typedef struct ipv4_pseudo_header ipv4_pseudo_header_t;
+
+/** Type definition of the internet version 4 pseudo header pointer.
+ * @see ipv4_pseudo_header
+ */
+typedef ipv4_pseudo_header_t *ipv4_pseudo_header_ref;
 
 /** Internet header.
Index: uspace/lib/net/include/ip_interface.h
===================================================================
--- uspace/lib/net/include/ip_interface.h	(revision 32eceb4ff0c0ddeba47997beaa5d0677aee84d3a)
+++ uspace/lib/net/include/ip_interface.h	(revision 1b22bd45ebc7f42217757e90fa6e5b57f6ed5d1d)
@@ -68,7 +68,7 @@
  * @param[in] error	The packet error reporting service. Prefixes the
  *			received packet.
- * @return		EOK on success.
+ * @returns		EOK on success.
  */
-typedef int (*tl_received_msg_t)(device_id_t device_id, packet_t *packet,
+typedef int (*tl_received_msg_t)(device_id_t device_id, packet_t packet,
     services_t receiver, services_t error);
 
Index: uspace/lib/net/include/ip_remote.h
===================================================================
--- uspace/lib/net/include/ip_remote.h	(revision 32eceb4ff0c0ddeba47997beaa5d0677aee84d3a)
+++ uspace/lib/net/include/ip_remote.h	(revision 1b22bd45ebc7f42217757e90fa6e5b57f6ed5d1d)
@@ -44,11 +44,11 @@
 
 extern int ip_set_gateway_req_remote(int, device_id_t, in_addr_t);
-extern int ip_packet_size_req_remote(int, device_id_t, packet_dimension_t *);
-extern int ip_received_error_msg_remote(int, device_id_t, packet_t *, services_t,
+extern int ip_packet_size_req_remote(int, device_id_t, packet_dimension_ref);
+extern int ip_received_error_msg_remote(int, device_id_t, packet_t, services_t,
     services_t);
 extern int ip_device_req_remote(int, device_id_t, services_t);
 extern int ip_add_route_req_remote(int, device_id_t, in_addr_t, in_addr_t,
     in_addr_t);
-extern int ip_send_msg_remote(int, device_id_t, packet_t *, services_t,
+extern int ip_send_msg_remote(int, device_id_t, packet_t, services_t,
     services_t);
 extern int ip_get_route_req_remote(int, ip_protocol_t, const struct sockaddr *,
Index: uspace/lib/net/include/net_interface.h
===================================================================
--- uspace/lib/net/include/net_interface.h	(revision 32eceb4ff0c0ddeba47997beaa5d0677aee84d3a)
+++ uspace/lib/net/include/net_interface.h	(revision 1b22bd45ebc7f42217757e90fa6e5b57f6ed5d1d)
@@ -44,8 +44,8 @@
 /*@{*/
 
-extern int net_get_device_conf_req(int, device_id_t, measured_string_t **,
+extern int net_get_device_conf_req(int, device_id_t, measured_string_ref *,
     size_t, char **);
-extern int net_get_conf_req(int, measured_string_t **, size_t, char **);
-extern void net_free_settings(measured_string_t *, char *);
+extern int net_get_conf_req(int, measured_string_ref *, size_t, char **);
+extern void net_free_settings(measured_string_ref, char *);
 extern int net_connect_module(void);
 
Index: uspace/lib/net/include/netif_local.h
===================================================================
--- uspace/lib/net/include/netif_local.h	(revision 32eceb4ff0c0ddeba47997beaa5d0677aee84d3a)
+++ uspace/lib/net/include/netif_local.h	(revision 1b22bd45ebc7f42217757e90fa6e5b57f6ed5d1d)
@@ -111,5 +111,5 @@
  *			message implementation.
  */
-extern int netif_send_message(device_id_t device_id, packet_t *packet,
+extern int netif_send_message(device_id_t device_id, packet_t packet,
     services_t sender);
 
@@ -158,5 +158,5 @@
  */
 extern int netif_get_addr_message(device_id_t device_id,
-    measured_string_t *address);
+    measured_string_ref address);
 
 /** Process the netif driver specific message.
@@ -193,20 +193,20 @@
  */
 extern int netif_get_device_stats(device_id_t device_id,
-    device_stats_t *stats);
-
-extern int netif_get_addr_req_local(int, device_id_t, measured_string_t **,
+    device_stats_ref stats);
+
+extern int netif_get_addr_req_local(int, device_id_t, measured_string_ref *,
     char **);
 extern int netif_probe_req_local(int, device_id_t, int, int);
-extern int netif_send_msg_local(int, device_id_t, packet_t *, services_t);
+extern int netif_send_msg_local(int, device_id_t, packet_t, services_t);
 extern int netif_start_req_local(int, device_id_t);
 extern int netif_stop_req_local(int, device_id_t);
-extern int netif_stats_req_local(int, device_id_t, device_stats_t *);
+extern int netif_stats_req_local(int, device_id_t, device_stats_ref);
 extern int netif_bind_service_local(services_t, device_id_t, services_t,
     async_client_conn_t);
 
 extern int find_device(device_id_t, netif_device_t **);
-extern void null_device_stats(device_stats_t *);
+extern void null_device_stats(device_stats_ref);
 extern void netif_pq_release(packet_id_t);
-extern packet_t *netif_packet_get_1(size_t);
+extern packet_t netif_packet_get_1(size_t);
 extern int netif_init_module(async_client_conn_t);
 
Index: uspace/lib/net/include/netif_remote.h
===================================================================
--- uspace/lib/net/include/netif_remote.h	(revision 32eceb4ff0c0ddeba47997beaa5d0677aee84d3a)
+++ uspace/lib/net/include/netif_remote.h	(revision 1b22bd45ebc7f42217757e90fa6e5b57f6ed5d1d)
@@ -41,11 +41,11 @@
 #include <net/packet.h>
 
-extern int netif_get_addr_req_remote(int, device_id_t, measured_string_t **,
+extern int netif_get_addr_req_remote(int, device_id_t, measured_string_ref *,
     char **);
 extern int netif_probe_req_remote(int, device_id_t, int, int);
-extern int netif_send_msg_remote(int, device_id_t, packet_t *, services_t);
+extern int netif_send_msg_remote(int, device_id_t, packet_t, services_t);
 extern int netif_start_req_remote(int, device_id_t);
 extern int netif_stop_req_remote(int, device_id_t);
-extern int netif_stats_req_remote(int, device_id_t, device_stats_t *);
+extern int netif_stats_req_remote(int, device_id_t, device_stats_ref);
 extern int netif_bind_service_remote(services_t, device_id_t, services_t,
     async_client_conn_t);
Index: uspace/lib/net/include/nil_local.h
===================================================================
--- uspace/lib/net/include/nil_local.h	(revision 32eceb4ff0c0ddeba47997beaa5d0677aee84d3a)
+++ uspace/lib/net/include/nil_local.h	(revision 1b22bd45ebc7f42217757e90fa6e5b57f6ed5d1d)
@@ -77,5 +77,5 @@
  * 			received function.
  */
-extern int nil_received_msg_local(int, device_id_t, packet_t *, services_t);
+extern int nil_received_msg_local(int, device_id_t, packet_t, services_t);
 
 /** Message processing function.
Index: uspace/lib/net/include/nil_remote.h
===================================================================
--- uspace/lib/net/include/nil_remote.h	(revision 32eceb4ff0c0ddeba47997beaa5d0677aee84d3a)
+++ uspace/lib/net/include/nil_remote.h	(revision 1b22bd45ebc7f42217757e90fa6e5b57f6ed5d1d)
@@ -39,5 +39,5 @@
 
 extern int nil_device_state_msg_remote(int, device_id_t, int);
-extern int nil_received_msg_remote(int, device_id_t, packet_t *, services_t);
+extern int nil_received_msg_remote(int, device_id_t, packet_t, services_t);
 
 #endif
Index: uspace/lib/net/include/packet_client.h
===================================================================
--- uspace/lib/net/include/packet_client.h	(revision 32eceb4ff0c0ddeba47997beaa5d0677aee84d3a)
+++ uspace/lib/net/include/packet_client.h	(revision 1b22bd45ebc7f42217757e90fa6e5b57f6ed5d1d)
@@ -61,7 +61,7 @@
  * @param[in] type	The type to be allocated at the beginning of the packet
  *			content.
- * @return		The typed pointer to the allocated memory.
- * @return		NULL if the packet is not valid.
- * @return		NULL if there is not enough memory left.
+ * @returns		The typed pointer to the allocated memory.
+ * @returns		NULL if the packet is not valid.
+ * @returns		NULL if there is not enough memory left.
  */
 #define PACKET_PREFIX(packet, type) \
@@ -76,7 +76,7 @@
  * @param[in] type	The type to be allocated at the end of the packet
  *			content.
- * @return		The typed pointer to the allocated memory.
- * @return		NULL if the packet is not valid.
- * @return		NULL if there is not enough memory left.
+ * @returns		The typed pointer to the allocated memory.
+ * @returns		NULL if the packet is not valid.
+ * @returns		NULL if there is not enough memory left.
  */
 #define PACKET_SUFFIX(packet, type) \
@@ -92,21 +92,21 @@
  * @param[in] suffix	The type of the suffix to be removed from the end of
  *			the packet content.
- * @return		EOK on success.
- * @return		EINVAL if the packet is not valid.
- * @return		ENOMEM if there is not enough memory left.
+ * @returns		EOK on success.
+ * @returns		EINVAL if the packet is not valid.
+ * @returns		ENOMEM if there is not enough memory left.
  */
 #define PACKET_TRIM(packet, prefix, suffix) \
 	packet_trim((packet), sizeof(prefix), sizeof(suffix))
 
-extern void *packet_prefix(packet_t *, size_t);
-extern void *packet_suffix(packet_t *, size_t);
-extern int packet_trim(packet_t *, size_t, size_t);
-extern int packet_copy_data(packet_t *, const void *, size_t);
-extern packet_id_t packet_get_id(const packet_t *);
-extern size_t packet_get_data_length(const packet_t *);
-extern void *packet_get_data(const packet_t *);
-extern int packet_get_addr(const packet_t *, uint8_t **, uint8_t **);
-extern int packet_set_addr(packet_t *, const uint8_t *, const uint8_t *, size_t);
-extern packet_t *packet_get_copy(int, packet_t *);
+extern void *packet_prefix(packet_t, size_t);
+extern void *packet_suffix(packet_t, size_t);
+extern int packet_trim(packet_t, size_t, size_t);
+extern int packet_copy_data(packet_t, const void *, size_t);
+extern packet_id_t packet_get_id(const packet_t);
+extern size_t packet_get_data_length(const packet_t);
+extern void *packet_get_data(const packet_t);
+extern int packet_get_addr(const packet_t, uint8_t **, uint8_t **);
+extern int packet_set_addr(packet_t, const uint8_t *, const uint8_t *, size_t);
+extern packet_t packet_get_copy(int phone, packet_t packet);
 
 /*@}*/
Index: uspace/lib/net/include/packet_remote.h
===================================================================
--- uspace/lib/net/include/packet_remote.h	(revision 32eceb4ff0c0ddeba47997beaa5d0677aee84d3a)
+++ uspace/lib/net/include/packet_remote.h	(revision 1b22bd45ebc7f42217757e90fa6e5b57f6ed5d1d)
@@ -37,7 +37,7 @@
 #include <sys/types.h>
 
-extern int packet_translate_remote(int, packet_t **, packet_id_t);
-extern packet_t *packet_get_4_remote(int, size_t, size_t, size_t, size_t);
-extern packet_t *packet_get_1_remote(int, size_t);
+extern int packet_translate_remote(int, packet_ref, packet_id_t);
+extern packet_t packet_get_4_remote(int, size_t, size_t, size_t, size_t);
+extern packet_t packet_get_1_remote(int, size_t);
 extern void pq_release_remote(int, packet_id_t);
 
Index: uspace/lib/net/include/socket_core.h
===================================================================
--- uspace/lib/net/include/socket_core.h	(revision 32eceb4ff0c0ddeba47997beaa5d0677aee84d3a)
+++ uspace/lib/net/include/socket_core.h	(revision 1b22bd45ebc7f42217757e90fa6e5b57f6ed5d1d)
@@ -66,8 +66,18 @@
 typedef struct socket_core socket_core_t;
 
+/** Type definition of the socket core pointer.
+ * @see socket_core
+ */
+typedef socket_core_t *socket_core_ref;
+
 /** Type definition of the socket port.
  * @see socket_port
  */
 typedef struct socket_port socket_port_t;
+
+/** Type definition of the socket port pointer.
+ * @see socket_port
+ */
+typedef socket_port_t *socket_port_ref;
 
 /** Socket core. */
@@ -101,5 +111,5 @@
  * the other use the remote addresses.
  */
-GENERIC_CHAR_MAP_DECLARE(socket_port_map, socket_core_t *);
+GENERIC_CHAR_MAP_DECLARE(socket_port_map, socket_core_ref);
 
 /** Ports map.
@@ -108,18 +118,18 @@
 INT_MAP_DECLARE(socket_ports, socket_port_t);
 
-extern void socket_cores_release(int, socket_cores_t *, socket_ports_t *,
-    void (*)(socket_core_t *));
-extern int socket_bind(socket_cores_t *, socket_ports_t *, int, void *, size_t,
+extern void socket_cores_release(int, socket_cores_ref, socket_ports_ref,
+    void (*)(socket_core_ref));
+extern int socket_bind(socket_cores_ref, socket_ports_ref, int, void *, size_t,
     int, int, int);
-extern int socket_bind_free_port(socket_ports_t *, socket_core_t *, int, int,
+extern int socket_bind_free_port(socket_ports_ref, socket_core_ref, int, int,
     int);
-extern int socket_create(socket_cores_t *, int, void *, int *);
-extern int socket_destroy(int, int, socket_cores_t *, socket_ports_t *,
-    void (*)(socket_core_t *));
-extern int socket_reply_packets(packet_t *, size_t *);
-extern socket_core_t *socket_port_find(socket_ports_t *, int, const char *,
+extern int socket_create(socket_cores_ref, int, void *, int *);
+extern int socket_destroy(int, int, socket_cores_ref, socket_ports_ref,
+    void (*)(socket_core_ref));
+extern int socket_reply_packets(packet_t, size_t *);
+extern socket_core_ref socket_port_find(socket_ports_ref, int, const char *,
     size_t);
-extern void socket_port_release(socket_ports_t *, socket_core_t *);
-extern int socket_port_add(socket_ports_t *, int, socket_core_t *,
+extern void socket_port_release(socket_ports_ref, socket_core_ref);
+extern int socket_port_add(socket_ports_ref, int, socket_core_ref,
     const char *, size_t);
 
Index: uspace/lib/net/include/tl_common.h
===================================================================
--- uspace/lib/net/include/tl_common.h	(revision 32eceb4ff0c0ddeba47997beaa5d0677aee84d3a)
+++ uspace/lib/net/include/tl_common.h	(revision 1b22bd45ebc7f42217757e90fa6e5b57f6ed5d1d)
@@ -51,13 +51,13 @@
 DEVICE_MAP_DECLARE(packet_dimensions, packet_dimension_t);
 
-extern int tl_get_ip_packet_dimension(int, packet_dimensions_t *,
-    device_id_t, packet_dimension_t **);
+extern int tl_get_ip_packet_dimension(int, packet_dimensions_ref,
+    device_id_t, packet_dimension_ref *);
 extern int tl_get_address_port(const struct sockaddr *, int, uint16_t *);
-extern int tl_update_ip_packet_dimension(packet_dimensions_t *, device_id_t,
+extern int tl_update_ip_packet_dimension(packet_dimensions_ref, device_id_t,
     size_t);
 extern int tl_set_address_port(struct sockaddr *, int, uint16_t);
-extern int tl_prepare_icmp_packet(int, int, packet_t *, services_t);
-extern int tl_socket_read_packet_data(int, packet_t **, size_t,
-    const packet_dimension_t *, const struct sockaddr *, socklen_t);
+extern int tl_prepare_icmp_packet(int, int, packet_t, services_t);
+extern int tl_socket_read_packet_data(int, packet_ref, size_t,
+    const packet_dimension_ref, const struct sockaddr *, socklen_t);
 
 #endif
Index: uspace/lib/net/include/tl_interface.h
===================================================================
--- uspace/lib/net/include/tl_interface.h	(revision 32eceb4ff0c0ddeba47997beaa5d0677aee84d3a)
+++ uspace/lib/net/include/tl_interface.h	(revision 1b22bd45ebc7f42217757e90fa6e5b57f6ed5d1d)
@@ -52,5 +52,5 @@
 /*@{*/
 
-extern int tl_received_msg(int, device_id_t, packet_t *, services_t, services_t);
+extern int tl_received_msg(int, device_id_t, packet_t, services_t, services_t);
 
 /*@}*/
Index: uspace/lib/net/include/tl_local.h
===================================================================
--- uspace/lib/net/include/tl_local.h	(revision 32eceb4ff0c0ddeba47997beaa5d0677aee84d3a)
+++ uspace/lib/net/include/tl_local.h	(revision 1b22bd45ebc7f42217757e90fa6e5b57f6ed5d1d)
@@ -45,8 +45,8 @@
  * @param[in] client_connection The client connection processing function. The
  *			module skeleton propagates its own one.
- * @return		EOK on successful module termination.
- * @return		Other error codes as defined for the module initialize
+ * @returns		EOK on successful module termination.
+ * @returns		Other error codes as defined for the module initialize
  *			function.
- * @return		Other error codes as defined for the REGISTER_ME() macro
+ * @returns		Other error codes as defined for the REGISTER_ME() macro
  *			function.
  */
@@ -62,6 +62,6 @@
  * @param[out] answer_count The last parameter for the actual answer in the
  *			answer parameter.
- * @return		EOK on success.
- * @return		Other error codes as defined for the module's message
+ * @returns		EOK on success.
+ * @returns		Other error codes as defined for the module's message
  *			standalone function.
  */
Index: uspace/lib/net/netif/netif_local.c
===================================================================
--- uspace/lib/net/netif/netif_local.c	(revision 32eceb4ff0c0ddeba47997beaa5d0677aee84d3a)
+++ uspace/lib/net/netif/netif_local.c	(revision 1b22bd45ebc7f42217757e90fa6e5b57f6ed5d1d)
@@ -92,5 +92,5 @@
  */
 int netif_send_msg_local(int netif_phone, device_id_t device_id,
-    packet_t *packet, services_t sender)
+    packet_t packet, services_t sender)
 {
 	fibril_rwlock_write_lock(&netif_globals.lock);
@@ -181,5 +181,5 @@
  */
 int netif_stats_req_local(int netif_phone, device_id_t device_id,
-    device_stats_t *stats)
+    device_stats_ref stats)
 {
 	fibril_rwlock_read_lock(&netif_globals.lock);
@@ -203,5 +203,5 @@
  */
 int netif_get_addr_req_local(int netif_phone, device_id_t device_id,
-    measured_string_t **address, char **data)
+    measured_string_ref *address, char **data)
 {
 	int rc;
@@ -253,5 +253,5 @@
  * @param[in] stats	The usage statistics.
  */
-void null_device_stats(device_stats_t *stats)
+void null_device_stats(device_stats_ref stats)
 {
 	bzero(stats, sizeof(device_stats_t));
@@ -307,5 +307,5 @@
  *
  */
-packet_t *netif_packet_get_1(size_t content)
+packet_t netif_packet_get_1(size_t content)
 {
 	return packet_get_1_remote(netif_globals.net_phone, content);
@@ -361,5 +361,5 @@
 	size_t length;
 	device_stats_t stats;
-	packet_t *packet;
+	packet_t packet;
 	measured_string_t address;
 	int rc;
Index: uspace/lib/net/netif/netif_remote.c
===================================================================
--- uspace/lib/net/netif/netif_remote.c	(revision 32eceb4ff0c0ddeba47997beaa5d0677aee84d3a)
+++ uspace/lib/net/netif/netif_remote.c	(revision 1b22bd45ebc7f42217757e90fa6e5b57f6ed5d1d)
@@ -60,5 +60,5 @@
  */
 int netif_get_addr_req_remote(int netif_phone, device_id_t device_id,
-    measured_string_t **address, char **data)
+    measured_string_ref *address, char **data)
 {
 	return generic_get_addr_req(netif_phone, NET_NETIF_GET_ADDR, device_id,
@@ -93,5 +93,5 @@
  */
 int
-netif_send_msg_remote(int netif_phone, device_id_t device_id, packet_t *packet,
+netif_send_msg_remote(int netif_phone, device_id_t device_id, packet_t packet,
     services_t sender)
 {
@@ -138,5 +138,5 @@
  */
 int netif_stats_req_remote(int netif_phone, device_id_t device_id,
-    device_stats_t *stats)
+    device_stats_ref stats)
 {
 	if (!stats)
Index: uspace/lib/net/nil/nil_remote.c
===================================================================
--- uspace/lib/net/nil/nil_remote.c	(revision 32eceb4ff0c0ddeba47997beaa5d0677aee84d3a)
+++ uspace/lib/net/nil/nil_remote.c	(revision 1b22bd45ebc7f42217757e90fa6e5b57f6ed5d1d)
@@ -74,5 +74,5 @@
  */
 int nil_received_msg_remote(int nil_phone, device_id_t device_id,
-    packet_t *packet, services_t target)
+    packet_t packet, services_t target)
 {
 	return generic_received_msg_remote(nil_phone, NET_NIL_RECEIVED,
Index: uspace/lib/net/tl/icmp_client.c
===================================================================
--- uspace/lib/net/tl/icmp_client.c	(revision 32eceb4ff0c0ddeba47997beaa5d0677aee84d3a)
+++ uspace/lib/net/tl/icmp_client.c	(revision 1b22bd45ebc7f42217757e90fa6e5b57f6ed5d1d)
@@ -57,14 +57,14 @@
  * @param[out] pointer	The ICMP header pointer.
  * @param[out] mtu	The ICMP header MTU.
- * @return		The ICMP header length.
- * @return		Zero if the packet contains no data.
+ * @returns		The ICMP header length.
+ * @returns		Zero if the packet contains no data.
  */
 int
-icmp_client_process_packet(packet_t *packet, icmp_type_t *type,
+icmp_client_process_packet(packet_t packet, icmp_type_t *type,
     icmp_code_t *code, icmp_param_t *pointer, icmp_param_t *mtu)
 {
-	icmp_header_t *header;
+	icmp_header_ref header;
 
-	header = (icmp_header_t *) packet_get_data(packet);
+	header = (icmp_header_ref) packet_get_data(packet);
 	if (!header ||
 	    (packet_get_data_length(packet) < sizeof(icmp_header_t))) {
@@ -92,7 +92,7 @@
  *
  * @param[in] packet	The packet.
- * @return		The ICMP header length in bytes.
+ * @returns		The ICMP header length in bytes.
  */
-size_t icmp_client_header_length(packet_t *packet)
+size_t icmp_client_header_length(packet_t packet)
 {
 	if (packet_get_data_length(packet) < sizeof(icmp_header_t))
Index: uspace/lib/net/tl/icmp_remote.c
===================================================================
--- uspace/lib/net/tl/icmp_remote.c	(revision 32eceb4ff0c0ddeba47997beaa5d0677aee84d3a)
+++ uspace/lib/net/tl/icmp_remote.c	(revision 1b22bd45ebc7f42217757e90fa6e5b57f6ed5d1d)
@@ -57,11 +57,11 @@
  * @param[in] mtu	The error MTU value.
  * @param[in] packet	The original packet.
- * @return		EOK on success.
- * @return		EPERM if the ICMP error notifications are disabled.
- * @return		ENOMEM if there is not enough memory left.
+ * @returns		EOK on success.
+ * @returns		EPERM if the ICMP error notifications are disabled.
+ * @returns		ENOMEM if there is not enough memory left.
  */
 int
 icmp_destination_unreachable_msg(int icmp_phone, icmp_code_t code,
-    icmp_param_t mtu, packet_t *packet)
+    icmp_param_t mtu, packet_t packet)
 {
 	async_msg_3(icmp_phone, NET_ICMP_DEST_UNREACH, (ipcarg_t) code,
@@ -78,9 +78,9 @@
  * @param[in] icmp_phone The ICMP module phone used for (semi)remote calls.
  * @param[in] packet	The original packet.
- * @return		EOK on success.
- * @return		EPERM if the ICMP error notifications are disabled.
- * @return		ENOMEM if there is not enough memory left.
+ * @returns		EOK on success.
+ * @returns		EPERM if the ICMP error notifications are disabled.
+ * @returns		ENOMEM if there is not enough memory left.
  */
-int icmp_source_quench_msg(int icmp_phone, packet_t *packet)
+int icmp_source_quench_msg(int icmp_phone, packet_t packet)
 {
 	async_msg_2(icmp_phone, NET_ICMP_SOURCE_QUENCH, 0,
@@ -98,9 +98,9 @@
  * @param[in] code	The error specific code.
  * @param[in] packet	The original packet.
- * @return		EOK on success.
- * @return		EPERM if the ICMP error notifications are disabled.
- * @return		ENOMEM if there is not enough memory left.
+ * @returns		EOK on success.
+ * @returns		EPERM if the ICMP error notifications are disabled.
+ * @returns		ENOMEM if there is not enough memory left.
  */
-int icmp_time_exceeded_msg(int icmp_phone, icmp_code_t code, packet_t *packet)
+int icmp_time_exceeded_msg(int icmp_phone, icmp_code_t code, packet_t packet)
 {
 	async_msg_2(icmp_phone, NET_ICMP_TIME_EXCEEDED, (ipcarg_t) code,
@@ -119,10 +119,10 @@
  * @param[in] pointer	The problematic parameter offset.
  * @param[in] packet	The original packet.
- * @return		EOK on success.
- * @return		EPERM if the ICMP error notifications are disabled.
- * @return		ENOMEM if there is not enough memory left.
+ * @returns		EOK on success.
+ * @returns		EPERM if the ICMP error notifications are disabled.
+ * @returns		ENOMEM if there is not enough memory left.
  */
 int icmp_parameter_problem_msg(int icmp_phone, icmp_code_t code,
-    icmp_param_t pointer, packet_t *packet)
+    icmp_param_t pointer, packet_t packet)
 {
 	async_msg_3(icmp_phone, NET_ICMP_PARAMETERPROB, (ipcarg_t) code,
